#ifndef _DYNAMICS_H_
#define _DYNAMICS_H_

#include "../types.h"
#include "quadrotor.h"

namespace imr {
	namespace dynamics {
		class Dynamics : public Quadrotor
		{
		private:
			Dynamics() { }

			// output file name
			const char * log_file;
			
			void tilt(const double roll, const double pitch, const double f, const double t);
			void turn(const double om, const double f, const double t);
			const Vector calculate_moment_inputs(const Vector W);

		public:
			Dynamics(const Vector & initial_X, const Vector & initial_V, const Vector & initial_OMEGA,
										const Matrix & initial_R, const int _type, const char * filename);

			~Dynamics() {}

			/// Control of the Vehicle
			double move_ctr(const OptVec & ctr);

			const State get_state() const { return state; }

			State get_leaders_state(const double s, int v) const;

			/// Write simulation outputs to m-file
			void write_to_mfile();
		};
	}
}
#endif
