#ifndef __MAP_H__
#define __MAP_H__


#include "mapLoader3d.h"
#include "../types.h"

#include <vector>

typedef imr::mapLoader3d::MapLoader3d Loader;

namespace imr {
	namespace map {
		class Map
		{
		private:
			const Vector start;
			const Vector goal;
			vector< Obstacle > obstacles;

			Trajectory initial_trajectory;

			void save();

		public:
			Map() { }
			Map(const Vector & sp, const Vector & gp, const Loader & loader);

			double obstacle_distance(const Point & p, const double t);
			double goal_distance(const Vector & v);

			const Vector get_start() const { return start; }
			const Vector get_goal() const { return goal; }

			const Trajectory get_initial_trajectory() const { return initial_trajectory; }
		};
	}
}
#endif
