#ifndef __3D_MAP_LAOADER_H__
#define __3D_MAP_LAOADER_H__

#include <cmath>
#include <vector>
#include <cstdlib>
#include <string>
#include <iostream>
#include "../types.h"

using namespace std;

namespace imr {
	namespace mapLoader3d {

        struct pt {
            double coords[3];

            pt(const double& x, const double& y, const double& z) {
                coords[0] = x;
                coords[1] = y;
                coords[2] = z;
            }

            const double operator [] (const int idx) const {
                return coords[idx];
            }
        };

		class MapLoader3d
		{
		private:
			vector< Obstacle > obstacles;
			int map_size;
            double eps;

		public:
			MapLoader3d(const string& filename);

			const int size() const {
				return obstacles.size();
			}

		 const vector<Obstacle> get_obstacles() const {
				return obstacles;
			}

  
		};
	}
}
#endif
