#include "time_measurement.h"

#include<fstream>
#include<iostream>

using namespace std;
using namespace imr::time;

TimeMeasurement::TimeMeasurement()
{
	start_ticks = 0;
	end_ticks = 0;
	total = 0;
}

void TimeMeasurement::start()
{
	start_ticks = SDL_GetTicks();
}

void TimeMeasurement::end()
{
	end_ticks = SDL_GetTicks();

	if (end_ticks > start_ticks) results.push_back(end_ticks-start_ticks);
	total += results.back();

	cout << "Consumed time: " << results.back() << endl;
}

void TimeMeasurement::write_results(const char * filename)
{
	ofstream out(filename);
	if (out.fail()) {
		cerr << "The file " << filename << " cannot be opened." << endl;
		exit(EXIT_FAILURE);
	}

	out << "total = " << total << ";\n";

	std::vector<Uint32>::iterator it = results.begin();
	out << "t = [ ";
	while (it != results.end()) {
		out << *it << " ";
		it++;
	}
	out << "];\n";
	out.close();
}
