#ifndef __TIME_MEASUREMENT_H__
#define __TIME_MEASUREMENT_H__

#include <vector>
#include <SDL/SDL.h>

namespace imr {
	namespace time {
		class TimeMeasurement
		{
		private:
			Uint32 start_ticks;
			Uint32 end_ticks;

			Uint32 total;
			std::vector<Uint32> results;

		public:
			TimeMeasurement();

			void start();
			void end();

			const int get_total() const { return total; }
			const int get_last() const { return results.back(); }

			void write_results(const char * filename);
		};
	}
}
#endif
