clear; clc; close all;

initialLoader;

sXo = sX;
sYo = sY;
sZo = sZ;

clear('sX');
clear('sY');
clear('sZ');

% Leader's trajectory
leaderLoader;
Xl = X;
Yl = Y;
Zl = Z;

% Follower's trajectory
fol1Loader;
Xf1 = X;
Yf1 = Y;
Zf1 = Z;

% Follower's trajectory
fol2Loader;
Xf2 = X;
Yf2 = Y;
Zf2 = Z;

% follower's trajectory
% fol3Loader;
% Xf3 = X;
% Yf3 = Y;
% Zf3 = Z;

% follower's trajectory
% load_fol4_results;
% Xf4 = X;
% Yf4 = Y;
% Zf4 = Z;

% follower's trajectory
% load_fol5_results;
% Xf5 = X;
% Yf5 = Y;
% Zf5 = Z;

loadMap;

%% 3-D

figure;
hold on;
title('Trajectory plot');

axis equal;
plot3(sXo,sYo,sZo, 'k--');
hold on;
plot3(Xl,Yl,Zl, 'm');
plot3(Xf1,Yf1,Zf1, 'r');
plot3(Xf2,Yf2,Zf2, 'g');
% plot3(Xf3,Yf3,Zf3, 'b');
% plot3(Xf4,Yf4,Zf4, 'r--');
% plot3(Xf5,Yf5,Zf5, 'g--');
xlabel('x [m]');
ylabel('y [m]');
zlabel('z [m]');

axis equal;
% 
% xlim([-1, 4.5]);
% ylim([-2.0, 2.0]);
% zlim([-0.5, 2.0]);
hold on;

for k = 1:size(oR,2)
    phi=linspace(0,pi,30);
	theta=linspace(0,2*pi,40);
	[phi,theta]=meshgrid(phi,theta);
 
    x=oR(k)*sin(phi).*cos(theta)+ones(size(phi))*oX(k);
	y=oR(k)*sin(phi).*sin(theta)+ones(size(phi))*oY(k);
    z=oR(k)*cos(phi)+ones(size(phi))*oZ(k);
    
    plot3(x,y,z, 'k');
end

%% XYZ

figure;
hold on;
title('Trajectory plot');

subplot(2,2,1);
% axis equal;
plot3(sXo,sYo,sZo, 'k--');
hold on;
plot3(Xl,Yl,Zl, 'm');
plot3(Xf1,Yf1,Zf1, 'r');
plot3(Xf2,Yf2,Zf2, 'g');
% plot3(Xf3,Yf3,Zf3, 'b');
% plot3(Xf4,Yf4,Zf4, 'r--');
% plot3(Xf5,Yf5,Zf5, 'g--');
xlabel('x [m]');
ylabel('y [m]');
zlabel('z [m]');



% axis equal;
%  
% xlim([-1.0, 6.0]);
% ylim([-2.0, 2.0]);
% zlim([-1.0, 1.0]);
hold on;

for k = 1:size(oR,2)
    phi=linspace(0,pi,30);
	theta=linspace(0,2*pi,40);
	[phi,theta]=meshgrid(phi,theta);
 
    x=oR(k)*sin(phi).*cos(theta)+ones(size(phi))*oX(k);
	y=oR(k)*sin(phi).*sin(theta)+ones(size(phi))*oY(k);
    z=oR(k)*cos(phi)+ones(size(phi))*oZ(k);
    
    plot3(x,y,z, 'k');
end

%% XZ

subplot(2,2,2);
plot(sXo,sZo, 'k--');
hold on;
plot(Xl,Zl, 'm');
plot(Xf1,Zf1, 'r');
plot(Xf2,Zf2, 'g');
% plot(Xf3,Zf3, 'b');
% plot(Xf4,Zf4, 'r--');
% plot(Xf5,Zf5, 'g--');
xlabel('x [m]');
ylabel('z [m]');

hold on;
for k = 1:size(oR,2)
    phi=linspace(0,pi,30);
	theta=linspace(0,2*pi,40);
	[phi,theta]=meshgrid(phi,theta);
 
    x=oR(k)*cos(theta)+ones(size(phi))*oX(k);
    z=oR(k)*sin(theta)+ones(size(phi))*oZ(k);

    plot(x,z, 'k');
end

% axis equal;
% 
% xlim([-1.0, 6.0]);
% ylim([-1.0, 1.0]);

%% XY

subplot(2,2,[3 4]);
plot(sXo,sYo, 'k--');
hold on;
plot(Xl,Yl, 'm');
plot(Xf1,Yf1, 'r');
plot(Xf2,Yf2, 'g');
% plot(Xf3,Yf3, 'b');
% plot(Xf4,Yf4, 'r--');
% plot(Xf5,Yf5, 'g--');
xlabel('x [m]');
ylabel('y [m]');

hold on;
for k = 1:size(oR,2)
    phi=linspace(0,pi,30);
	theta=linspace(0,2*pi,40);
	[phi,theta]=meshgrid(phi,theta);
 
    x=oR(k)*cos(theta)+ones(size(phi))*oX(k);
    y=oR(k)*sin(theta)+ones(size(phi))*oY(k);

    plot(x,y, 'k');
end
% axis equal; 
% 
% xlim([-1.0, 6.0]);
% ylim([-2.0, 2.0]);

legend('Initial guess', 'Leader', 'Follower 1', 'Follower 2', 'Follower 3','Location','SouthEastOutside')
