clear; clc; close all;

load_results;

figure;
hold on;
title('Trajectory plot');

subplot(2,2,1);
axis equal;
plot3(X,Y,Z);
xlabel('x');
ylabel('y');
zlabel('z');

subplot(2,2,2);
plot(X,Z);
xlabel('x');
ylabel('z');

subplot(2,2,3);
plot(X,Y);
xlabel('x');
ylabel('y');

figure;

subplot(3, 1, 1);
plot(t_sim, Rx);
ylabel('\phi [-]');
subplot(3, 1, 2);
plot(t_sim, Ry);
ylabel('\psi [-]');
subplot(3, 1, 3);
plot(t_sim, Rz);
ylabel('\theta [-]');

figure;

subplot(3, 1, 1);
plot(t_sim, Wx);
ylabel('\Omega_x [rad/s]');
subplot(3, 1, 2);
plot(t_sim, Wy);
ylabel('\Omega_y [rad/s]');
subplot(3, 1, 3);
plot(t_sim, Wz);
ylabel('\Omega_z [rad/s]');

figure;

subplot(4, 1, 1);
plot(t_sim(1:size(f,2)), f);
ylabel('f [N]');
subplot(4, 1, 2);
plot(t_sim(1:size(Mx,2)), Mx);
ylabel('m_x [N.m]');
subplot(4, 1, 3);
plot(t_sim(1:size(Mx,2)), My);
ylabel('m_y [N.m]');
subplot(4, 1, 4);
plot(t_sim(1:size(Mx,2)), Mz);
ylabel('m_z [N.m]');