#ifndef __TYPES_H__
#define __TYPES_H__

#include <vector>
#include "utils.h"

typedef imr::utils::Point Point;
typedef imr::utils::Vector Vector;
typedef imr::utils::Matrix Matrix;
typedef imr::utils::quadrotor_opt OptVec;
typedef imr::utils::formation_spec FSpec;
typedef imr::utils::formation_diff FDiff;
typedef imr::utils::quadrotor_state State;
typedef imr::utils::quadrotor_limits Limits;
typedef imr::utils::quadrotor_control Control;
typedef imr::utils::obstacle Obstacle;

// Used in Obstacle - holding obstacle nodes
typedef std::vector<Vector> Points;

// Used in Solver - sampled trajectory
typedef std::vector<Point> Samples;

// For purposes of formation driving
typedef std::vector<OptVec> Trajectory;

// Logging of the simulation
typedef std::vector<State> StateHistory;
typedef std::vector<Control> ControlHistory;
#endif
