#ifndef __WORLD_H__
#define __WORLD_H__

#include <vector>

#include "map/map.h"
#include "robot/robot_leader.h"
#include "robot/robot_follower.h"

/**
 * Structure World provides data sharing between the project and the solver.
 * */
namespace imr {
	struct World {
		imr::robot::RobotLeader * leader;
		std::vector<imr::robot::RobotFollower *> followers;
		imr::map::Map * map;

		World() { }

		~World() {
			while (!followers.empty()) {
				delete *followers.end();
				followers.pop_back();
			}

			delete leader;
			delete map;
		}
	};
}
#endif

#ifdef DEFINE_WORLD
	#define EXTERN /*definition - no extern*/
#else
	#define EXTERN extern
#endif

EXTERN imr::World world;
